Đến nội dung


Hình ảnh
- - - - -

[Yêu cầu lsp] Tính diện tích


  • Please log in to reply
9 replies to this topic

#1 18011985

18011985

    biết lệnh properties

  • Members
  • PipPipPipPip
  • 255 Bài viết
Điểm đánh giá: 61 (tàm tạm)

Đã gửi 18 August 2011 - 01:52 PM

Mình viết 1 đoạn lsp với ý tưởng như sau:
- Tính diện tích 1 hình loại bỏ các hình con ở bên trong.
- Biểu diễn hình tính diện tích.
+ Mắc phải lỗi sau:
- Tràn bộ nhớ của cad vì mình cho nó đối chiếu với nhiều hình (bản vẽ cad kèm theo)
- Nếu pick vào phạm vi hình ngoài trước ( không pick hình trong ) cho kết quả như ý muốn. Nhưng nếu pick hình con trước thì kết quả không được.
+ Diễn đàn có nhiều lsp tính diện tích nhưng mình vẫn muốn dùng cái mình làm ra vì như thế nếu có sai ở đâu còn sửa được nên vậy rất mong các bạn giúp mình. Sau đây là đoạn code:
(defun c:po(/ CVMAX CVTEST DTMAX DTMIN DTTEST ICHAY IMASS ITRUNG KQCVTEST KQDTTEST KQTTTEST NMASS SSARE1 SSAREA SSAREA1 SSAREAN TTTEST)
;;;----------------------------- Doc file massprop ---------------------------------------
(defun docfilemass (/ CVMASS DTMASS testmass XMASS YMASS MASSFILE N)
(setq massfile (open "c:\\testarea.mpr" "r"))
(Read-line massfile)
(Read-line massfile)
(Read-line massfile)
(setq dtmass (vl-string-trim " " (Read-line massfile)))
(setq cvmass (vl-string-trim " " (Read-line massfile)))
(Read-line massfile)
(Read-line massfile)
(setq Xmass (vl-string-trim " " (Read-line massfile)))
(setq Ymass (vl-string-trim " " (Read-line massfile)))
(close massfile)
(setq n (strlen dtmass));;;--------------- Lay gia tri dien tich massprop --------------
(setq testmass (vl-string-position 32 dtmass))
(setq dtmass (substr dtmass (+ testmass 21) n))
(setq n (strlen cvmass));;;----------------- Lay gia tri chu vi massprop --------------
(setq testmass (vl-string-position 32 cvmass))
(setq cvmass (substr cvmass (+ testmass 16) n))
(setq n (strlen Xmass));;;----------------- Lay gia tri toa do X massprop --------------
(setq testmass (vl-string-position 32 Xmass))
(setq Xmass (substr Xmass (+ testmass 17) n))
(setq n (strlen Ymass));;;----------------- Lay gia tri toa do Y massprop --------------
(setq testmass (vl-string-position 32 Ymass))
(setq Ymass (substr Ymass (+ testmass 2) n))
(setq dttest (atof dtmass))
(setq cvtest (atof cvmass))
(setq tttest (cons (atof Xmass) (atof Ymass)))
)
;;;----------------------------- So sanh gia tri massprop --------------------------------
(defun sosanhmass (/ ntest itest)
(if (= ichay 0)
(progn
(setq kqdttest (append kqdttest (list dttest)))
(setq kqcvtest (append kqcvtest (list cvtest)))
(setq kqtttest (append kqtttest (list tttest)))
(setq itrung 1)
);end progn
(progn
(setq ntest (-(length kqtttest)1))
(setq itest 0)
(while (<= itest ntest)
(if (equal tttest (nth itest kqtttest))
(progn
(vl-cmdf "erase" ssarea "")
(alert "\n Vung nay da tinh ")
(setq itrung 0)
(setq itest (1+ ntest))
(setq imass (1+ nmass))
);end progn
(progn
(setq kqdttest (append kqdttest (list dttest)))
(setq kqcvtest (append kqcvtest (list cvtest)))
(setq kqtttest (append kqtttest (list tttest)))
(setq itrung 1)
);end progn
);end if
(setq itest (1+ itest))
);end while
);end progn
);end if
);end sosanhmass
;;;----------------------------- Xet dien tich max --------------------------------
(defun xetdtmax (dmax / imax nmax itinh imass nmass mmass)
(vl-load-com)
(setq imax 0)
(setq nmax (-(length dmax)1))
(while (<= imax nmax)
(if (= imax 0)
(progn(setq dtmax (nth imax dmax))(setq itinh imax))
(if (< dtmax (nth imax dmax))
(progn(setq dtmax (nth imax dmax))(setq itinh imax))
);end if
);end if
(setq imax (1+ imax))
);end while
(setq cvmax (nth itinh kqcvtest))
(setq nmass (sslength ssarea))
(setq imass 0)
(setq nmass (sslength ssarea))
(if (> nmass 1)
(progn
(setq mmass nmass)
(while (< imass nmass)
(setq ssarean (ssname ssarea (setq mmass (1- mmass))))
(vl-cmdf "area" "o" ssarean)
(setq dtmin (getvar "area"))
(if (equal dtmin dtmax 0.0001)
(progn
(alert "sai")
(vl-cmdf "select" (ssname ssarea mmass) "")
(setq ssarea1 (ssget "P"))
(setq imass (1+ nmass))
);end progn
);end if
(setq imass (1+ imass))
);end while
);end progn
(setq ssarea1 (ssget "X" (list(cons 0 "REGION")(cons 8 "areatest"))))
);end if
(setq ssarea nil)
);end xetdtmax
;;;----------------------------------------------------------------------------
(setq ichay 0)
(setvar "osmode" 0)
(while(setq ptarea (getpoint "\n Chon vung tinh dien tich: "))
(setvar "clayer" "areatest")
(vl-cmdf "-boundary" "a" "o" "r" "" ptarea "")
(setq ssarea (ssget "X" (list(cons 0 "REGION")(cons 8 "areatest"))))
(cond
((= ssarea nil)(alert "\n Vung dien tich chua khep kin"))
((/= ssarea nil)
(progn
(setq imass 0)
(setq nmass (sslength ssarea))
(setq mmass nmass)
(while (< imass nmass)
(setq ssarean (ssname ssarea (setq mmass(1- mmass))))
(vl-cmdf "massprop" ssarean "" "y" "c:\\testarea.mpr")
(docfilemass)
(sosanhmass)
(setq imass (1+ imass))
);end while
);end progn
)
);end cond
(setq ichay (1+ ichay))
(if (= itrung 1)
(progn
(xetdtmax kqdttest)
(vl-cmdf "change" ssarea1 "" "p" "la" "areatest1" "")
);end progn
);end if
(setq ssarea (ssget "X" (list(cons 0 "REGION")(cons 8 "areatest"))))
(if (/= ssarea nil)(vl-cmdf "erase" ssarea ""))
(setq ssarea nil)
);end while
(princ)
); end pick vung
File cad: http://www.cadviet.c...drawing1_81.dwg
  • 0
Trăng 16 trăng tròn
Em 16 bụng ... như trăng

Hướng dẫn sử dụng diễn đàn:
Để cảm ơn hay bài viết có ích: Ấn dấu + cuối bài.
Không vừa lòng hay bài spam: Ấn dấu - cuối bài.

#2 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 18 August 2011 - 05:40 PM

Mình không chạy được lisp của bạn, vì nó cứ báo sai ^^
Có điều này mình thắc mắc : bạn chỉ cần tính DT, vậy khai thác thông tin của massprop có ích lợi chi ?
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#3 18011985

18011985

    biết lệnh properties

  • Members
  • PipPipPipPip
  • 255 Bài viết
Điểm đánh giá: 61 (tàm tạm)

Đã gửi 18 August 2011 - 06:31 PM

Mình vẫn chạy tốt mà
Sao vậy nhỉ????
  • 0
Trăng 16 trăng tròn
Em 16 bụng ... như trăng

Hướng dẫn sử dụng diễn đàn:
Để cảm ơn hay bài viết có ích: Ấn dấu + cuối bài.
Không vừa lòng hay bài spam: Ấn dấu - cuối bài.

#4 18011985

18011985

    biết lệnh properties

  • Members
  • PipPipPipPip
  • 255 Bài viết
Điểm đánh giá: 61 (tàm tạm)

Đã gửi 19 August 2011 - 02:39 PM

Hix cuối tuần rồi mà mọi người vẫn bận không xem hộ mình được lsp.
P/s Ketxu: bạn chạy lsp cùng với file đính kèm nhé.
  • 0
Trăng 16 trăng tròn
Em 16 bụng ... như trăng

Hướng dẫn sử dụng diễn đàn:
Để cảm ơn hay bài viết có ích: Ấn dấu + cuối bài.
Không vừa lòng hay bài spam: Ấn dấu - cuối bài.

#5 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 19 August 2011 - 08:56 PM

Hề, ta giải quyết vấn đề ý tưởng trước : nếu chỉ cần lấy Diện tích thì bác khai thác thông tin massprop làm gì ?
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#6 18011985

18011985

    biết lệnh properties

  • Members
  • PipPipPipPip
  • 255 Bài viết
Điểm đánh giá: 61 (tàm tạm)

Đã gửi 22 August 2011 - 08:58 AM

Vậy theo Ketxu thì việc lọc các vùng diện tích bị trùng, điện tích tạo bởi tổ hợp các hình tính sao? Bạn có thể cho mình vd tính diện tích loại bỏ các điểm pick trùng Và tổ hợp các hình nữa (hình khuyết) không? Rất mong được học hỏi thêm từ mọi người có thể ý tưởng mình bị cứng nhắc quá.
  • 0
Trăng 16 trăng tròn
Em 16 bụng ... như trăng

Hướng dẫn sử dụng diễn đàn:
Để cảm ơn hay bài viết có ích: Ấn dấu + cuối bài.
Không vừa lòng hay bài spam: Ấn dấu - cuối bài.

#7 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 22 August 2011 - 08:20 PM

Dạo này em bận quá, có khi không theo dõi thưỡng xuyên được ^^
- Vì các vấn đề bác nêu chỉ xử lý trong 1 lần chạy lisp 2D, nên bác có thể :
+ Pick vùng -> tạo bound (Pline) -> tạo list dạng (cons DT (point list / tâm )). Lần sau mỗi lần lấy diện tích mới : check list DT, nếu trùng thì check tiếp point list hoặc tâm hoặc gì gì đó hè. Vấn đề này có thể nhiều ý tưởng nên tùy ý bác
+ Hình khuyết : Theo e nhớ thì nếu pick vào hình khuyết nó sẽ tạo ra nhiều boundary, ta gom tất cả lại rồi lấy thằng có DT to nhất trừ đi đống còn lại ^^ (e chưa test nhé).
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#8 18011985

18011985

    biết lệnh properties

  • Members
  • PipPipPipPip
  • 255 Bài viết
Điểm đánh giá: 61 (tàm tạm)

Đã gửi 23 August 2011 - 08:03 AM

Dạo này em bận quá, có khi không theo dõi thưỡng xuyên được ^^
- Vì các vấn đề bác nêu chỉ xử lý trong 1 lần chạy lisp 2D, nên bác có thể :
+ Pick vùng -> tạo bound (Pline) -> tạo list dạng (cons DT (point list / tâm )). Lần sau mỗi lần lấy diện tích mới : check list DT, nếu trùng thì check tiếp point list hoặc tâm hoặc gì gì đó hè. Vấn đề này có thể nhiều ý tưởng nên tùy ý bác
+ Hình khuyết : Theo e nhớ thì nếu pick vào hình khuyết nó sẽ tạo ra nhiều boundary, ta gom tất cả lại rồi lấy thằng có DT to nhất trừ đi đống còn lại ^^ (e chưa test nhé).

Vậy thì xác định tâm hình khuyết thế nào, nếu tạo list tâm các hình thì hình khuyết sẽ lấy thía nào, massprop mới cho ra kết quả tâm hình khuyết chứ bác. Nhưng có vấn đề càng nghiều hình khuyết máy chạy càng chậm bác ạ.
  • 0
Trăng 16 trăng tròn
Em 16 bụng ... như trăng

Hướng dẫn sử dụng diễn đàn:
Để cảm ơn hay bài viết có ích: Ấn dấu + cuối bài.
Không vừa lòng hay bài spam: Ấn dấu - cuối bài.

#9 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 23 August 2011 - 06:22 PM

Tâm chỉ mang tính tương đối, miễn là nó đi 1 cặp với Diện tích, việc 2 hình trùng tâm, trùng diện tích cũng k dễ gặp đâu bác. Hơn nữa lisp lấy tâm trên diễn đàn cũng có ối mà :o Nói bo khó hiểu, bác cần làm gì thì viết lên hình xem sao ^^
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#10 pdle

pdle

    biết lệnh mtext

  • Members
  • PipPipPipPip
  • 286 Bài viết
Điểm đánh giá: 124 (tàm tạm)

Đã gửi 23 August 2011 - 08:17 PM

Anh thử lisp này xem thế nào ? Cái này tính được diện tích của một hình mà bên trong bị khoét !

;; free lisp from cadviet.com
;;; this lisp was downloaded from http://www.cadviet.com/forum/index.php?showtopic=41175
(defun c:Bou (/ pt1 lstEname emax x lstEname1 Elast Res Area Centroid PrinMo PrinDi MoofIn ProfIn )
(setvar "cmdecho" 0)
(vl-load-com)
(setq Elast (entlast)
pt1 (getpoint "\nPick mot diem trong vung can tao region: ")
); setq
(command "-boundary" "a" "o" "r" "" pt1 "")
(while (setq Elast (entnext Elast)) (setq lstEname (cons Elast lstEname)))
(if (/= lstEname nil)
(progn
(setq emax(ssb lstEname) lstEname1 (vl-remove emax lstEname) ss1 (ssadd))
(foreach x lstEname1 (ssadd x ss1))
(command "subtract" emax "" ss1 "")
(setq fod (vlax-ename->vla-object (entlast))
Area (vlax-get fod 'Area)
Centroid (vlax-get fod 'Centroid)
PrinMo (vlax-get fod 'PrincipalMoments)
PrinDi (vlax-get fod 'PrincipalDirections)
MoofIn (vlax-get fod 'MomentofInertia)
ProfIn (vlax-get fod 'ProductofInertia)
)
(entdel (entlast))
(setq Res (strcat "Dien tich = " (rtos Area) "\n")
Res (strcat Res "Trong tam:" " XC = " (rtos (car Centroid)) " " " YC = " (rtos (cadr Centroid)) "\n")
Res (strcat Res "Moment quan tinh: Jx = " (rtos (car MoofIn)) " " "Jy = " (rtos (cadr MoofIn)) "\n")
Res (strcat Res "Moment quan tinh XY: Jxy = " (rtos ProfIn) "\n")
Res (strcat Res "Truc chinh 1: ( " (rtos (nth 0 PrinDi)) " , " (rtos (nth 2 PrinDi)) "). Moment quan tinh chinh truc 1: Jxx= " (rtos (car PrinMo)) "\n")
Res (strcat Res "Truc chinh 2: ( " (rtos (nth 1 PrinDi)) " , " (rtos (nth 3 PrinDi)) "). Moment quan tinh chinh truc 2: Jyy= " (rtos (cadr PrinMo)) "\n")
)
(princ Res)
); progn
(princ "\n Da co loi xay ra, co the do duong bao khong kin! Hay kiem tra lai")
); if
(princ)
)
(defun ssb ( ss / ss1 boundary e minPt maxPt ) ;select region boundary
(setq boundary (boundarySS ss))
(foreach e (mapcar 'vlax-ename->vla-object ss)
(vla-getBoundingBox e 'minPt 'maxPt)
(setq minPt (vlax-safearray->list minPt)
maxPt (vlax-safearray->list maxPt))
(if (equal (list minPt maxPt ) boundary 0.001)
(setq ss1 (vlax-vla-object->ename e))
)
); foreach
)
;ham tra ve 2 diem (LowerLeft TopRight) cua hinh chu nhat bao quanh cac doi tuong
(defun boundarySS (ss / all_max all_min ll maxpt minpt ur);
(setq all_min (list)
all_max (list) )
(foreach x (mapcar 'vlax-ename->vla-object ss)
(vla-GetBoundingBox x 'minpt 'maxpt)
(setq all_min (cons (vlax-safearray->list minpt) all_min)
all_max (cons (vlax-safearray->list maxpt) all_max) )
) ;foreach
(setq ll (list (car (vl-sort (mapcar 'car all_min) '<))
(car (vl-sort (mapcar 'cadr all_min) '<))
(car (vl-sort (mapcar 'caddr all_min) '<)) ) ;list
ur (list (last (vl-sort (mapcar 'car all_max) '<))
(last (vl-sort (mapcar 'cadr all_max) '<))
(last (vl-sort (mapcar 'caddr all_max) '<))) ;list
) ;setq
(list ll ur )
)

  • 1
Share your knowledge. It is a way to achieve immortality !

***

PS: Nếu bài viết của mình có ích, xin hãy "Bình chọn cho bài viết này" nhé :D